"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var assign = require("object-assign");
var FormInput = (function (_super) {
    __extends(FormInput, _super);
    function FormInput(props) {
        var _this = _super.call(this, props) || this;
        _this.renderField = _this.renderField.bind(_this);
        _this.onValueChanged = _this.onValueChanged.bind(_this);
        return _this;
    }
    FormInput.prototype.renderField = function (field, index) {
        var fieldDef = this.props.registry[field.type];
        if (!fieldDef || !fieldDef.input) {
            console.warn('Field definition is not registered: ' + field.type);
            return;
        }
        var value = this.props.value[field.id];
        var component = React.createElement(fieldDef.input, {
            registry: this.props.registry,
            index: index,
            field: field,
            value: value,
            values: this.props.value,
            attempt: this.props.attempt,
            onValueChange: this.onValueChanged,
        });
        return (React.createElement("div", { className: 'form-submission-field', key: index }, component));
    };
    FormInput.prototype.onValueChanged = function (field, value, error) {
        var newValue = assign({}, this.props.value);
        newValue[field.id] = value;
        this.errors = this.errors || {};
        if (error) {
            this.errors[field.id] = error;
        }
        else {
            delete this.errors[field.id];
        }
        // NOTE: If there are no errors from the fields, set errors to be null.
        if (Object.getOwnPropertyNames(this.errors).length === 0) {
            this.errors = null;
        }
        this.props.onChange(newValue, this.errors);
    };
    // render displays a list of fields based on the field registry.
    FormInput.prototype.render = function () {
        return (React.createElement("div", { className: 'form-submission' }, this.props.fields.map(this.renderField)));
    };
    return FormInput;
}(React.PureComponent));
FormInput.defaultProps = {
    value: {}
};
exports.FormInput = FormInput;
