"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var assign = require("object-assign");
var FormInput_1 = require("../FormInput");
var NestedFormInput = (function (_super) {
    __extends(NestedFormInput, _super);
    function NestedFormInput(props) {
        var _this = _super.call(this, props) || this;
        _this.renderEntry = _this.renderEntry.bind(_this);
        _this.onCreateEntry = _this.onCreateEntry.bind(_this);
        _this.onDeleteEntry = _this.onDeleteEntry.bind(_this);
        _this.onEntryValueChanged = _this.onEntryValueChanged.bind(_this);
        _this.nestedEntryErrors = {};
        return _this;
    }
    NestedFormInput.prototype.render = function () {
        return (React.createElement("div", null,
            React.createElement("button", { type: 'button', onClick: this.onCreateEntry }, "Create"),
            this.props.value.map(this.renderEntry)));
    };
    NestedFormInput.prototype.renderEntry = function (entry, index) {
        return (React.createElement(NestedFormEntry, { key: index, index: index, value: entry, fields: this.props.field.fields, registry: this.props.registry, onChange: this.onEntryValueChanged, onDelete: this.onDeleteEntry }));
    };
    NestedFormInput.prototype.onCreateEntry = function () {
        var entries = this.props.value.slice();
        entries.push({});
        this.props.onValueChange(this.props.field, entries, this.buildFieldError());
    };
    NestedFormInput.prototype.onDeleteEntry = function (index) {
        var entries = this.props.value.slice();
        entries.splice(index, 1);
        delete this.nestedEntryErrors[index];
        this.props.onValueChange(this.props.field, entries, this.buildFieldError());
    };
    NestedFormInput.prototype.onEntryValueChanged = function (value, error, index) {
        var newValue = this.props.value.slice();
        newValue[index] = value;
        var newError = assign({}, this.nestedEntryErrors);
        if (error) {
            this.nestedEntryErrors[index] = error;
        }
        else {
            delete this.nestedEntryErrors[index];
        }
        this.props.onValueChange(this.props.field, newValue, this.buildFieldError());
    };
    NestedFormInput.prototype.buildFieldError = function () {
        var errors = [];
        for (var prop in this.nestedEntryErrors) {
            errors.push(this.nestedEntryErrors[prop]);
        }
        if (errors.length === 0) {
            return null;
        }
        return {
            error: true,
            errorMsg: "nestedError",
            details: errors,
        };
    };
    return NestedFormInput;
}(React.PureComponent));
NestedFormInput.defaultProps = {
    value: [{}]
};
exports.NestedFormInput = NestedFormInput;
var NestedFormEntry = (function (_super) {
    __extends(NestedFormEntry, _super);
    function NestedFormEntry() {
        var _this = _super.call(this) || this;
        _this.onValueChanged = _this.onValueChanged.bind(_this);
        _this.onDeleted = _this.onDeleted.bind(_this);
        return _this;
    }
    NestedFormEntry.prototype.render = function () {
        return (React.createElement("div", { className: 'form-submission-nested-entry' },
            React.createElement("button", { type: 'button', onClick: this.onDeleted }, "Delete"),
            React.createElement(FormInput_1.FormInput, { fields: this.props.fields, registry: this.props.registry, value: this.props.value, onChange: this.onValueChanged })));
    };
    NestedFormEntry.prototype.onDeleted = function () {
        this.props.onDelete(this.props.index);
    };
    NestedFormEntry.prototype.onValueChanged = function (value, errors) {
        this.props.onChange(value, errors, this.props.index);
    };
    return NestedFormEntry;
}(React.PureComponent));
